/*
 * EntableController.java
 *
 * Created on 2006/07/17, 13:10
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package aaa.bbb;

import java.math.BigInteger;
import java.util.Collection;
import javax.annotation.Resource;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.Query;
import javax.transaction.UserTransaction;

/**
 *
 * @author Administrator
 */
public class EntableController {
    
    /** Creates a new instance of EntableController */
    public EntableController() {
    }

    private Entable entable;

    @Resource
    private UserTransaction utx;

    @PersistenceUnit(unitName = "mbcolfromdbPU")
    private EntityManagerFactory emf;

    private EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    private int batchSize = 20;

    private int firstItem = 0;

    public String createSetup() {
        this.entable = new Entable();
        return "entable_create";
    }

    public String create() {
        EntityManager em = getEntityManager();
        try {
            utx.begin();
            em.persist(entable);
            utx.commit();
            addSuccessMessage("Entable was successfully created.");
        } catch (Exception ex) {
            try {
                addErrorMessage(ex.getLocalizedMessage());
                utx.rollback();
            } catch (Exception e) {
                addErrorMessage(e.getLocalizedMessage());
            }
        }
        em.close();
        return "entable_list"; 
    }

    public String detailSetup() {
        setEntableFromRequestParam();
        return "entable_detail";
    }

    public String editSetup() {
        setEntableFromRequestParam();
        return "entable_edit";
    }

    public String edit() {
        EntityManager em = getEntityManager();
        try {
            utx.begin();
            entable = em.merge(entable);
            utx.commit();
            addSuccessMessage("Entable was successfully updated.");
        } catch (Exception ex) {
            try {
                addErrorMessage(ex.getLocalizedMessage());
                utx.rollback();
            } catch (Exception e) {
                addErrorMessage(e.getLocalizedMessage());
            }
        }
        em.close();
        return "entable_list"; 
    }

    public String destroy() {
        EntityManager em = getEntityManager();
        try {
            utx.begin();
            Entable entable = getEntableFromRequestParam();
            entable = em.merge(entable);
            em.remove(entable);
            utx.commit();
            addSuccessMessage("Entable was successfully deleted.");
        } catch (Exception ex) {
            try {
                addErrorMessage(ex.getLocalizedMessage());
                utx.rollback();
            } catch (Exception e) {
                addErrorMessage(e.getLocalizedMessage());
            }
        }
        em.close();
        return "entable_list"; 
    }

    public Entable getEntableFromRequestParam() {
        EntityManager em = getEntityManager();
        String param = FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap().get("id");
        java.math.BigInteger id = new java.math.BigInteger(param);
        Entable o = em.find(Entable.class, id);
        em.close();
        return o;
    }

    public void setEntableFromRequestParam() {
        Entable entable = getEntableFromRequestParam();
        setEntable(entable);
    }

    public Collection getEntables() {
        EntityManager em = getEntityManager();
        Query q = em.createQuery("select object(o) from Entable as o");
        q.setMaxResults(batchSize);
        q.setFirstResult(firstItem);
        Collection c = q.getResultList();
        em.close();
        return c;
    }

    public Entable getEntable() {
        return entable;
    }

    public void setEntable(Entable entable) {
        this.entable = entable;
    }

    public static void addErrorMessage(String msg) {
        FacesMessage facesMsg = new FacesMessage(FacesMessage.SEVERITY_ERROR, msg, msg);
        FacesContext fc = FacesContext.getCurrentInstance();
        fc.addMessage(null, facesMsg);
    }

    public static void addSuccessMessage(String msg) {
        FacesMessage facesMsg = new FacesMessage(FacesMessage.SEVERITY_INFO, msg, msg);
        FacesContext fc = FacesContext.getCurrentInstance();
        fc.addMessage("successInfo", facesMsg);
    }

    public Entable findEntable(BigInteger id) {
        EntityManager em = getEntityManager();
        Entable o = (Entable) em.find(Entable.class, id);
        em.close();
        return o;
    }

    public int getItemCount() {
        EntityManager em = getEntityManager();
        int count = ((Long) em.createQuery("select count(o) from Entable as o").getSingleResult()).intValue();em.close();
        return count;
    }

    public int getFirstItem() {
        return firstItem;
    }

    public int getLastItem() {
        int size = getItemCount();
        return firstItem + batchSize > size ? size : firstItem + batchSize;
    }

    public int getBatchSize() {
        return batchSize;
    }

    public String next() {
        if (firstItem + batchSize < getItemCount()) {
            firstItem += batchSize;
        }
        return "entable_list";
    }

    public String prev() {
        firstItem -= batchSize;
        if (firstItem < 0) {
            firstItem = 0;
        }
        return "entable_list";
    }
    
}
